#include "AT24C02_DRV.h"
#include "..\IIC\IIC.h"

bit AT24C02_ByteWR(unsigned char WordAddr, unsigned char WrValue)
{
	IIC_Start();
	IIC_SendOneByte(AT24C02_WR_OPERATION);
	if(IIC_RecvACK_Error())
	{
		IIC_Stop();
		return AT24C02_WR_ERROR;
	}
	IIC_SendOneByte(WordAddr);
	if(IIC_RecvACK_Error())
	{
		IIC_Stop();
		return AT24C02_WR_ERROR;
	}
	IIC_SendOneByte(WrValue);
	if(IIC_RecvACK_Error())
	{
		IIC_Stop();
		return AT24C02_WR_ERROR;
	}
	IIC_Stop();
	
	return AT24C02_WR_SUCCESS;
}

unsigned char AT24C02_ByteRD(unsigned char WordAddr)
{
	unsigned char RdValue;
	
	IIC_Start();
	IIC_SendOneByte(AT24C02_WR_OPERATION);
	if(IIC_RecvACK_Error())
	{
		IIC_Stop();
		return 0;
	}
	IIC_SendOneByte(WordAddr);
	if(IIC_RecvACK_Error())
	{
		IIC_Stop();
		return 0;
	}
	IIC_Start();
	IIC_SendOneByte(AT24C02_RD_OPERATION);
	if(IIC_RecvACK_Error())
	{
		IIC_Stop();
		return 0;
	}
	RdValue = IIC_RecvOneByte();
	IIC_SendACK(NACK);
	IIC_Stop();

	return RdValue;
}